• 数组中第K个最大元素-快速排序,堆排序,优先队列


    一、题目

    给定整数数组 nums 和整数 k,请返回数组中第 k 个最大的元素。
    请注意,你需要找的是数组排序后的第 k 个最大的元素,而不是第 k 个不同的元素。
    你必须设计并实现时间复杂度为 O(n) 的算法解决此问题。
    在这里插入图片描述

    二、思路解析

    1.理解题意
    根据示例明确题意,知道主要考察的是排序算法。

    2.快速排序
    我们可以用快速排序来解决这个问题,先对原数组排序,再返回倒数第 kk 个位置,这样平均时间复杂度是 O(n \log n)O(nlogn),但其实我们可以做的更快。
    快速排序是一个典型的分治算法。

    3.基于堆排序
    我们也可以使用堆排序来解决这个问题——建立一个大根堆,做 k - 1k−1 次删除操作后堆顶元素就是我们要找的答案。在很多语言中,都有优先队列或者堆的的容器可以直接使用,但是在面试中,面试官更倾向于让更面试者自己实现一个堆。搞懂「建堆」、「调整」和「删除」的过程。

    4.暴力解法
    5.优先队列

    三、代码

    1.基于快速排序C++

    class Solution {
    public:
        int quickSelect(vector<int>& a, int l, int r, int index) {
            int q = randomPartition(a, l, r);
            if (q == index) {
                return a[q];
            } else {
                return q < index ? quickSelect(a, q + 1, r, index) : quickSelect(a, l, q - 1, index);
            }
        }
    
        inline int randomPartition(vector<int>& a, int l, int r) {
            int i = rand() % (r - l + 1) + l;
            swap(a[i], a[r]);
            return partition(a, l, r);
        }
    
        inline int partition(vector<int>& a, int l, int r) {
            int x = a[r], i = l - 1;
            for (int j = l; j < r; ++j) {
                if (a[j] <= x) {
                    swap(a[++i], a[j]);
                }
            }
            swap(a[i + 1], a[r]);
            return i + 1;
        }
    
        int findKthLargest(vector<int>& nums, int k) {
            srand(time(0));
            return quickSelect(nums, 0, nums.size() - 1, nums.size() - k);
        }
    };
    
    
    

    2.基于快速排序java

    class Solution {
        Random random = new Random();
    
        public int findKthLargest(int[] nums, int k) {
            return quickSelect(nums, 0, nums.length - 1, nums.length - k);
        }
    
        public int quickSelect(int[] a, int l, int r, int index) {
            int q = randomPartition(a, l, r);
            if (q == index) {
                return a[q];
            } else {
                return q < index ? quickSelect(a, q + 1, r, index) : quickSelect(a, l, q - 1, index);
            }
        }
    
        public int randomPartition(int[] a, int l, int r) {
            int i = random.nextInt(r - l + 1) + l;
            swap(a, i, r);
            return partition(a, l, r);
        }
    
        public int partition(int[] a, int l, int r) {
            int x = a[r], i = l - 1;
            for (int j = l; j < r; ++j) {
                if (a[j] <= x) {
                    swap(a, ++i, j);
                }
            }
            swap(a, i + 1, r);
            return i + 1;
        }
    
        public void swap(int[] a, int i, int j) {
            int temp = a[i];
            a[i] = a[j];
            a[j] = temp;
        }
    }
    
    
    

    3.基于堆排序C++

    class Solution {
    public:
        void maxHeapify(vector<int>& a, int i, int heapSize) {
            int l = i * 2 + 1, r = i * 2 + 2, largest = i;
            if (l < heapSize && a[l] > a[largest]) {
                largest = l;
            } 
            if (r < heapSize && a[r] > a[largest]) {
                largest = r;
            }
            if (largest != i) {
                swap(a[i], a[largest]);
                maxHeapify(a, largest, heapSize);
            }
        }
    
        void buildMaxHeap(vector<int>& a, int heapSize) {
            for (int i = heapSize / 2; i >= 0; --i) {
                maxHeapify(a, i, heapSize);
            } 
        }
    
        int findKthLargest(vector<int>& nums, int k) {
            int heapSize = nums.size();
            buildMaxHeap(nums, heapSize);
            for (int i = nums.size() - 1; i >= nums.size() - k + 1; --i) {
                swap(nums[0], nums[i]);
                --heapSize;
                maxHeapify(nums, 0, heapSize);
            }
            return nums[0];
        }
    };
    
    
    

    4.基于堆排序Java

    class Solution {
        public int findKthLargest(int[] nums, int k) {
            int heapSize = nums.length;
            buildMaxHeap(nums, heapSize);
            for (int i = nums.length - 1; i >= nums.length - k + 1; --i) {
                swap(nums, 0, i);
                --heapSize;
                maxHeapify(nums, 0, heapSize);
            }
            return nums[0];
        }
    
        public void buildMaxHeap(int[] a, int heapSize) {
            for (int i = heapSize / 2; i >= 0; --i) {
                maxHeapify(a, i, heapSize);
            } 
        }
    
        public void maxHeapify(int[] a, int i, int heapSize) {
            int l = i * 2 + 1, r = i * 2 + 2, largest = i;
            if (l < heapSize && a[l] > a[largest]) {
                largest = l;
            } 
            if (r < heapSize && a[r] > a[largest]) {
                largest = r;
            }
            if (largest != i) {
                swap(a, i, largest);
                maxHeapify(a, largest, heapSize);
            }
        }
    
        public void swap(int[] a, int i, int j) {
            int temp = a[i];
            a[i] = a[j];
            a[j] = temp;
        }
    }
    
    
    

    5.暴力解法Java

    import java.util.Arrays;
    
    public class Solution {
    
        public int findKthLargest(int[] nums, int k) {
            int len = nums.length;
            Arrays.sort(nums);
            return nums[len - k];
        }
    }
    
    
    

    6.暴力解法C++

    #include 
    #include 
    
    using namespace std;
    
    class Solution {
    public:
        int findKthLargest(vector<int> &nums, int k) {
            int size = nums.size();
            sort(begin(nums), end(nums));
            return nums[size - k];
        }
    };
    
    
    

    7.优先队列Java

    import java.util.Comparator;
    import java.util.PriorityQueue;
    
    public class Solution {
    
        public int findKthLargest(int[] nums, int k) {
            int len = nums.length;
            // 使用一个含有 k 个元素的最小堆,PriorityQueue 底层是动态数组,为了防止数组扩容产生消耗,可以先指定数组的长度
            PriorityQueue<Integer> minHeap = new PriorityQueue<>(k, Comparator.comparingInt(a -> a));
            // Java 里没有 heapify ,因此我们逐个将前 k 个元素添加到 minHeap 里
            for (int i = 0; i < k; i++) {
                minHeap.offer(nums[i]);
            }
    
            for (int i = k; i < len; i++) {
                // 看一眼,不拿出,因为有可能没有必要替换
                Integer topElement = minHeap.peek();
                // 只要当前遍历的元素比堆顶元素大,堆顶弹出,遍历的元素进去
                if (nums[i] > topElement) {
                    // Java 没有 replace(),所以得先 poll() 出来,然后再放回去
                    minHeap.poll();
                    minHeap.offer(nums[i]);
                }
            }
            return minHeap.peek();
        }
    }
    
    
    

    四、总结

    1.基于快速排序的选择
    时间复杂度:O(n),
    空间复杂度:O(logn),递归使用栈空间的空间代价的期望为 O(logn)。

    2.基于堆排序
    时间复杂度:O(nlogn),建堆的时间代价是 O(n),删除的总代价是 O(klogn),因为 k 空间复杂度:O(logn),即递归使用栈空间的空间代价。

    3.暴力解法
    时间复杂度:O(NlogN),这里 N 是数组的长度,算法的性能消耗主要在排序,JDK 默认使用快速排序,因此时间复杂度为 O(NlogN);
    空间复杂度:O(logN),这里认为编程语言使用的排序方法是「快速排序」,空间复杂度为递归调用栈的高度,为 logN。
    4.优先队列
    时间复杂度:O(NlogK),遍历数据O(N),堆内元素调整O(logK);
    空间复杂度:O(K)。

  • 相关阅读:
    qt使用mysql数据库(自学笔记)
    R语言ggplot2可视化:使用ggplot2可视化散点图、使用scale_color_viridis_d函数指定数据点的配色方案
    【JUC】JMM
    2022Java面试题大全,附答案,最新整理
    vscode+svn的配置和简单使用
    代码随想录 Day38 完全背包问题 LeetCode T70 爬楼梯 T322 零钱兑换 T279 完全平方数
    【毕业设计】机器学习的溢油特征提取与识别
    回溯算法集合(全排列,组合,子集)
    【综述】推荐系统偏差问题 & 去偏最新研究进展(Bias and Debias in Recommender System)
    【保姆级·创建对象】如何通过factory-method创建对象
  • 原文地址:https://blog.csdn.net/weixin_45594172/article/details/127095342